#ifndef ELDBUS_MODEL_SIGNAL_EO_HH
#define ELDBUS_MODEL_SIGNAL_EO_HH
#include <Eo.h>

extern "C" {
#include "efl_model.eo.h"
#include "eldbus_model_arguments.eo.h"
#include "eldbus_model_signal.eo.h"
#include "eo_base.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
#include "efl_model.eo.hh"
#include "eldbus_model_arguments.eo.hh"
#include "eo_base.eo.hh"
namespace eldbus { namespace model { 
struct Signal;
} } 
namespace efl { namespace eo { template<> struct is_eolian_object< ::eldbus::model::Signal> : ::std::true_type {}; } }

namespace eo_cxx {
namespace eldbus { namespace model { 
struct Signal {
   static Eo_Class const* _eo_class()
   {
      return ELDBUS_MODEL_SIGNAL_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   operator ::eldbus::model::Signal() const;
   operator ::eldbus::model::Signal&();
   operator ::eldbus::model::Signal const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Signal,  ::efl::Model,  ::eldbus::model::Arguments,  ::eo::Base> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Signal const ,  ::efl::Model const ,  ::eldbus::model::Arguments const ,  ::eo::Base const > operator&() const { return {this}; }
   /// @endcond
};
} } 
}
namespace eldbus { namespace model { 
struct Signal : ::efl::eo::concrete
   , EO_CXX_INHERIT( ::efl::Model)
   , EO_CXX_INHERIT( ::eldbus ::model::Arguments)
   , EO_CXX_INHERIT( ::eo::Base)
{
   explicit Signal( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   explicit Signal(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   Signal(Signal const& other) = default;
   Signal(Signal&& other) = default;
   Signal& operator=(Signal const& other) = default;
   Signal& operator=(Signal&& other) = default;
   Signal()
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class());
   }
   Signal( ::efl::eo::concrete parent)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class());
   }
   template <typename F> Signal(F f, typename ::std::enable_if< ::efl::eolian::is_callable<F>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class(), f);
   }
   static Eo_Class const* _eo_class()
   {
      return ELDBUS_MODEL_SIGNAL_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Signal,  ::efl::Model,  ::eldbus::model::Arguments,  ::eo::Base> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Signal const ,  ::efl::Model const ,  ::eldbus::model::Arguments const ,  ::eo::Base const > operator&() const { return {this}; }
   /// @endcond
};
static_assert(sizeof(Signal) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Signal>::value, "");
} } 
#include "eldbus_model_signal.eo.impl.hh"
#endif
